=== modified file 'src/com/goldencode/p2j/util/TransactionManager.java'
--- old/src/com/goldencode/p2j/util/TransactionManager.java	2022-07-12 13:55:19 +0000
+++ new/src/com/goldencode/p2j/util/TransactionManager.java	2022-09-06 18:22:04 +0000
@@ -495,6 +495,17 @@
 **                           only when the root block is popped (this includes appserver agents).
 **     RFB 20220712          Added isRootExternal method which is similar to isRootNestingLevel, but it uses
 **                           the nearest external block nesting instead of the root. Ref #6578.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
+**     CA  20220906          Extracted all BufferManager state which requires notification for 
+**                           'isImportantBlock' to an external TxWrapper class (including the private class 
+**                           here), to allow the scopeable BufferManager state related only to buffers (and  
+**                           not transaction related) to be registered for scope notifications in a lazy 
+**                           manner, when buffers are accessed/used/opened.
 */
 
 /*
@@ -553,6 +564,7 @@
 package com.goldencode.p2j.util;
 
 import java.util.*;
+import java.util.BitSet;
 import java.util.logging.*;
 import com.goldencode.util.Stack;
 import com.goldencode.p2j.net.*;
@@ -560,6 +572,7 @@
 import com.goldencode.p2j.persist.meta.*;
 import com.goldencode.p2j.security.*;
 import com.goldencode.p2j.security.SecurityManager;
+import com.goldencode.p2j.ui.LogicalTerminal;
 
 import static com.goldencode.p2j.util.BlockType.*;
 
@@ -700,12 +713,6 @@
     * TRANSACTION-MODE AUTOMATIC language statement is in effect).
     */
    private static final int APPSERVER_ROOT_BLOCK_INDEX = 0;
-
-   /**
-    * JVM-wide list of objects which create Scopeable objects to be registered in each user's
-    * session.  By design this cannot be context-local.
-    */
-   private static final List<ScopeableFactory> scopeableFactories = new ArrayList<>();
    
    /** Logger (this is JVM-wide rather than being context-local). */
    private static final Logger LOG = LogHelper.getLogger(TransactionManager.class.getName());
@@ -852,24 +859,6 @@
    {
       return workArea.obtain().op;
    }
-   
-   /**
-    * Register an object which will be asked to provide a
-    * <code>Scopeable</code> each time a new work area context is created.
-    * The resulting object is added to the work area's list of objects to
-    * be notified as runtime scopes are started and finished.
-    * <p>
-    * These factories typically are registered during server bootstrap and
-    * are not removed during the lifetime of the server process. A factory
-    * should only be registered once per server process.
-    *
-    * @param   factory
-    *          Factory to be registered.
-    */
-   public static void registerScopeableFactory(ScopeableFactory factory)
-   {
-      scopeableFactories.add(factory);
-   }
 
    /**
     * Adds the given object into the list of objects for the current block
@@ -973,36 +962,30 @@
    }
 
    /**
-    * Adds the given object into the list of global objects needing scope 
-    * related notifications upon the entry and exit from every block. This
-    * list is context-local so this registration is specific to the current
-    * context.
-    * <p>
-    * <b>WARNING: this method should be called before the first call to
-    * {@link #pushScope}. This is necessary since this list is global and
-    * there is no history of which notifications have been provided. Thus,
-    * if <code>pushScope</code> has been called before this method, then
-    * the notifications of scope start for any scopes that have already been
-    * added will never be seen by the target AND more importantly the 
-    * registered target will receive end scope notifications for those
-    * scopes even though there was no matching start scope notification!
-    * If this method can't be called from the static initializer of this
-    * class, the target must implement a facility that is safe with this
-    * limitation (<code>scopeFinished</code> being called for scopes that
-    * never had a matching <code>scopeStart</code>).</b>
-    * <p>
-    * These registrations are global and will not be removed.
-    *
+    * Registers the instance for scope notifications at the current block.
+    * <p>
+    * This will call {@link Scopeable#scopeStart()} to notify for the scope processing.
+    * 
     * @param    target
-    *           The object reference to be notified on scope start and end. 
-    *           This cannot be <code>null</code>.
+    *           The scopeable instance.
     */
-   public static void registerScopeable(Scopeable target)
+   public static void registerBlockScopeable(Scopeable target)
    {
-      registerScopeable(workArea.obtain(), target);
+      registerBlockScopeable(workArea.obtain(), target);
    }
 
    /**
+    * Register the target scopeable as pending, to be added to the next block.
+    * 
+    * @param    target
+    *           The scopeable instance.
+    */
+   public static void registerPendingScopeable(Scopeable target)
+   {
+      registerPendingScopeable(workArea.obtain(), target);
+   }
+   
+   /**
     * Register the given <code>Resettable</code> object in order to reset it
     * at specific points of block processing. 
     *
@@ -3545,50 +3528,63 @@
    }
    
    /**
-    * Adds the given object into the list of global objects needing scope 
-    * related notifications upon the entry and exit from every block. This
-    * list is context-local so this registration is specific to the current
-    * context.
-    * <p>
-    * <b>WARNING: this method should be called before the first call to
-    * {@link #pushScope}. This is necessary since this list is global and
-    * there is no history of which notifications have been provided. Thus,
-    * if <code>pushScope</code> has been called before this method, then
-    * the notifications of scope start for any scopes that have already been
-    * added will never be seen by the target AND more importantly the 
-    * registered target will receive end scope notifications for those
-    * scopes even though there was no matching start scope notification!
-    * If this method can't be called from the static initializer of this
-    * class, the target must implement a facility that is safe with this
-    * limitation (<code>scopeFinished</code> being called for scopes that
-    * never had a matching <code>scopeStart</code>).</b>
-    * <p>
-    * These registrations are global and will not be removed.
-    *
-    * @param    wa
-    *           Context local work area.  Must not be {@code null}.
-    * @param    target
-    *           The object reference to be notified on scope start and end. 
-    *           This cannot be <code>null</code>.
-    */
-   private static void registerScopeable(WorkArea wa, Scopeable target)
-   {
-      // prevent ConcurrentModificationException
-      if (wa.nowIterating == wa.scopeList)
-      {
-         if (LOG.isLoggable(Level.WARNING))
+    * Registers the instance for scope notifications at the current block.
+    * <p>
+    * This will call {@link Scopeable#scopeStart()} to notify for the scope processing.
+    * 
+    * @param    wa
+    *           The {@link WorkArea} instance.
+    * @param    target
+    *           The scopeable instance.
+    */
+   private static void registerBlockScopeable(WorkArea wa, Scopeable target)
+   {
+      BlockDefinition block = wa.blocks.peek();
+      registerScopeable(block, target, true);
+   }
+   
+   /**
+    * Register the target scopeable as pending, to be added to the next block.
+    * 
+    * @param    wa
+    *           The {@link WorkArea} instance.
+    * @param    target
+    *           The scopeable instance.
+    */
+   private static void registerPendingScopeable(WorkArea wa, Scopeable target)
+   {
+      wa.pendingScopeables.add(target);
+   }
+
+   /**
+    * Registers the instance for scope notifications at the current block.
+    * 
+    * @param    block
+    *           The target block.
+    * @param    target
+    *           The scopeable instance.
+    * @param    start
+    *           Flag indicating if {@link Scopeable#scopeStart()} should be executed.
+    */
+   private static void registerScopeable(BlockDefinition block, Scopeable target, boolean start)
+   {
+      if (block.scopeList == null)
+      {
+         block.scopeList = new ArrayList<>();
+         block.scopeables = new BitSet();
+      }
+      
+      int id = target.getScopeId().ordinal();
+      if (!block.scopeables.get(id))
+      {
+         block.scopeables.set(id, true);
+         block.scopeList.add(target);
+         if (start)
          {
-            log(Level.WARNING,
-                "registerScopeable",
-                "Illegal attempt to register Scopeable",
-                new Throwable());
+            // process the scope start
+            target.scopeStart();
          }
-         
-         return;
       }
-      
-      // add the object to the list to receive scope notifications
-      wa.scopeList.add(target);
    }
    
    /**
@@ -3762,6 +3758,7 @@
       wa.trackedUndoables = null;
       wa.trackUndoables = false;
       wa.deferredDynExt = null;
+      wa.pendingScopeables.clear();
    }
    
    /**
@@ -4364,6 +4361,17 @@
                                                 blockType,
                                                 block);
       
+      if ((props & PROP_ENDKEY) != 0 && wa.lt != null && wa.isInteractive()) // wa.lt is NULL for headless mode
+      {
+         // LT must not be added for agents or batch mode
+         // this is registered directly at the block, to avoid using the 'pending'
+         
+         // WARNING: LT has dependencies on top-level blocks (including external); currently, such blocks have
+         // by default the ENDKEY property - if this registration changes, attention is needed to register
+         // LT scopeable for these blocks. 
+         registerScopeable(blk, wa.lt, false);
+      }
+      
       // add our block
       wa.blocks.push(blk);
       
@@ -4401,6 +4409,17 @@
          }
       }
       
+      if (wa.bm.isImportantBlockTransition()) 
+      {
+         BufferManager.registerTxScopeable(wa.bm);
+      }
+      
+      if (isGlobalBlock(wa))
+      {
+         // the global block must be added, for the scoped dictionary's global block.
+         BufferManager.registerPendingScopeable(wa.bm);
+      }
+
       // notify Scopeables that scope has opened
       processScopeNotifications(wa, blk, true);
       
@@ -7387,61 +7406,96 @@
          log(Level.FINE, "processScopeNotifications", "start = " + start);
       }
       
+      if (!wa.pendingScopeables.isEmpty())
+      {
+         for (Scopeable target : wa.pendingScopeables)
+         {
+            registerScopeable(blk, target, false);
+         }
+         wa.pendingScopeables.clear();
+      }
+      
+      // check scopeables inherited from previous block
+      BlockDefinition prev = getBlock(wa, 1);
+      int accumMgrId = ScopeId.ACCUMULATOR_MANAGER.ordinal();
+      if (!blk.topLevel                                               && 
+          prev != null                                                && 
+          prev.scopeables != null                                     && 
+          prev.scopeables.get(accumMgrId)                             &&
+          (blk.scopeables == null || !blk.scopeables.get(accumMgrId)))
+      {
+         registerScopeable(blk, AccumulatorManager.getInstance(), false);
+      }
+      
       Object prevReferent = wa.pm.getProcessedProcedure();
 
       try
       {
-         Object referent = null;
-         boolean delayed = false;
+         if (!(blk.topLevel || blk.scopeables != null))
+         {
+            // nothing to notify
+            return;
+         }
+         
+         Object referent;
+         boolean delayed;
          // can not call for start, as the procedure is not yet initialized
-         if (!start && isTopLevelBlock(wa) && !isGlobalBlock(wa))
+         if (!start && blk.topLevel && !isGlobalBlock(wa))
          {
             referent = wa.pm._thisProcedure();
             wa.pm.setProcessedProcedure(referent);
             
-            if (getNearestTopLevelType(wa) == EXTERNAL_PROC)
-            {
-               delayed = wa.pm._isPersistent(referent) && !wa.pm._isDelayedDelete(referent);
-            }
+            delayed = getNearestTopLevelType(wa) == EXTERNAL_PROC && 
+                      wa.pm._isPersistent(referent)               && 
+                      !wa.pm._isDelayedDelete(referent);
+         }
+         else
+         {
+            delayed = false;
+            referent = null;
          }
          
-         if (start)
+         if (start && blk.topLevel)
          {
             // procedure scopes need to be opened first
             wa.procScopeable.scopeStart();
          }
          
-         wa.nowIterating = wa.scopeList;
-         for (Scopeable target : wa.scopeList)
+         if (blk.scopeList != null)
          {
-            try
+            wa.nowIterating = blk.scopeList;
+            for (int i = 0; i < blk.scopeList.size(); i++)
             {
-               if (start)
-               {
-                  target.scopeStart();
-               }
-               else
-               {
-                  target.scopeFinished();
-                  
-                  if (delayed)
+               Scopeable target = blk.scopeList.get(i);
+               try
+               {
+                  if (start)
                   {
-                     wa.pm.addScopeable(referent, target);
+                     target.scopeStart();
                   }
                   else
                   {
-                     target.scopeDeleted();
+                     target.scopeFinished();
+                     
+                     if (delayed)
+                     {
+                        wa.pm.addScopeable(referent, target);
+                     }
+                     else
+                     {
+                        target.scopeDeleted();
+                     }
                   }
                }
-            }
-            
-            catch (Throwable thr)
-            {
-               deferError(wa, (start ? "scopeStart" : "scopeFinished"), thr, false);
+               
+               catch (Throwable thr)
+               {
+                  deferError(wa, (start ? "scopeStart" : "scopeFinished"), thr, false);
+               }
             }
          }
          
-         if (!start)
+         if (!start && blk.topLevel)
          {
             // procedure scopes need to be finished last
             wa.procScopeable.scopeFinished();
@@ -7766,33 +7820,44 @@
       }
    
       /**
-       * Adds the given object into the list of global objects needing scope 
-       * related notifications upon the entry and exit from every block. This
-       * list is context-local so this registration is specific to the current
-       * context.
-       * <p>
-       * <b>WARNING: this method should be called before the first call to
-       * {@link #pushScope}. This is necessary since this list is global and
-       * there is no history of which notifications have been provided. Thus,
-       * if <code>pushScope</code> has been called before this method, then
-       * the notifications of scope start for any scopes that have already been
-       * added will never be seen by the target AND more importantly the 
-       * registered target will receive end scope notifications for those
-       * scopes even though there was no matching start scope notification!
-       * If this method can't be called from the static initializer of this
-       * class, the target must implement a facility that is safe with this
-       * limitation (<code>scopeFinished</code> being called for scopes that
-       * never had a matching <code>scopeStart</code>).</b>
-       * <p>
-       * These registrations are global and will not be removed.
-       *
-       * @param    target
-       *           The object reference to be notified on scope start and end. 
-       *           This cannot be <code>null</code>.
-       */
-      public void registerScopeable(Scopeable target)
-      {
-         TransactionManager.registerScopeable(wa, target);
+       * Registers the instance for scope notifications at the current block.
+       * <p>
+       * This will call {@link Scopeable#scopeStart()} to notify for the scope processing.
+       * 
+       * @param    target
+       *           The scopeable instance.
+       */
+      public void registerBlockScopeable(Scopeable target)
+      {
+         TransactionManager.registerBlockScopeable(wa, target);
+      }
+      
+      /**
+       * Register the target scopeable as pending, to be added to the next block.
+       * 
+       * @param    target
+       *           The scopeable instance.
+       */
+      public void registerPendingScopeable(Scopeable target)
+      {
+         TransactionManager.registerPendingScopeable(wa, target);
+      }
+      
+      /**
+       * Registers the instance for scope notifications at the nearest {@link #findNearestTopLevel() top level}
+       * block.
+       * <p>
+       * WARNING: this must be called only for instances which require notifications only for 
+       * top-level blocks, as this will registered the instance at the nearest top-level block and call 
+       * {@link Scopeable#scopeStart()} to emulate as if it was called when the top-level block started.
+       * 
+       * @param    target
+       *           The scopeable instance.
+       */
+      public void registerTopLevelScopeable(Scopeable target)
+      {
+         BlockDefinition block = nearestTopLevel(wa);
+         registerScopeable(block, target, true);
       }
    
       /**
@@ -10100,9 +10165,15 @@
 
       /** Helper to use the ErrorManager without any context local lookups. */
       public ErrorManager.ErrorHelper em;
-
-      /** Registry of all objects needing start and end scope callbacks. */
-      private final List<Scopeable> scopeList = new ArrayList<>();
+      
+      /** The buffer manager instance, active only on server-side. */
+      public BufferManager bm;
+
+      /** The logical terminal instance, active only on server-side. */
+      public LogicalTerminal lt;
+
+      /** The set of pending scopeables to be registered for the next block. */
+      private final Set<Scopeable> pendingScopeables = Collections.newSetFromMap(new IdentityHashMap<>());
       
       /**
        * Map of Commitables to get a commit notification after all other commits occur in a full transaction;
@@ -10245,6 +10316,24 @@
       /** Cached value of the {@link AppServerManager#isRemote()} state.*/
       private Boolean remote = null;
       
+      /** Flag indicating if this is a user-interactive session. */
+      private Boolean interactive = null;
+      
+      /**
+       * Check if the current session is interactive (i.e. not appserver agent or batch process).
+       * 
+       * @return    See above.
+       */
+      private boolean isInteractive()
+      {
+         if (interactive == null)
+         {
+            interactive = !(isRemote() || LogicalTerminal.isInBatchMode());
+         }
+         
+         return interactive;
+      }
+      
       /**
        * Check if this session is an appserver session or not.
        * 
@@ -10750,19 +10839,7 @@
       /**
        * Obtains the context-local instance of the contained global work
        * area.  The first time this method is invoked in a context, a new
-       * <code>WorkArea</code> instance is lazily created.  This is done here
-       * rather than using the more elegant mechanism of overriding the
-       * superclass' <code>initialValue</code> method, because we must ensure
-       * we do not trigger an infinite loop.  Infinite looping can occur
-       * because a new work area requires that each {@link ScopeableFactory}
-       * create its {@link Scopeable} instance.  These objects may call back
-       * into the <code>TransactionManager</code> to register for various
-       * service hooks, which will in turn trigger a call to this method.
-       * By implementing the <code>WorkArea</code> instantiation here, we can
-       * set the <code>ContextContainer</code>'s contents <i>before</i> the
-       * factories are asked to create their <code>Scopeable</code>s.  Thus,
-       * any recursion into this method during <code>Scopeable</code>
-       * initialization is safe.
+       * <code>WorkArea</code> instance is lazily created.
        *
        * @return  The work area associated with this context.
        */
@@ -10796,23 +10873,15 @@
             
             wa.pm = ProcedureManager.getProcedureHelper();
             wa.em = ErrorManager.getErrorHelper();
+            if (!SessionManager.get().isLeaf())
+            {
+               // only on server-side
+               wa.bm = BufferManager.get();
+               wa.lt = (wa.headless ? null : LogicalTerminal.getInstance());
+            }
             
             wa.em.setHeadless(wa.headless);
-            
-            // create all scopeable objects to be registered using the
-            // registered Scopeable factories
-            for (ScopeableFactory factory : scopeableFactories)
-            {
-               Scopeable scope = factory.createScopeable();
-               
-               // non-null return values must be added to the list otherwise
-               // it is silently bypassed
-               if (scope != null)
-               {
-                  wa.scopeList.add(scope);
-               }
-            }
-            
+
             wa.procScopeable = ProcedureManager.getScopeable();
          }
          

=== modified file 'src/com/goldencode/p2j/util/TypeFactory.java'
--- old/src/com/goldencode/p2j/util/TypeFactory.java	2022-01-20 16:27:48 +0000
+++ new/src/com/goldencode/p2j/util/TypeFactory.java	2022-09-06 18:22:04 +0000
@@ -29,6 +29,12 @@
 **                  argument.
 **     VVT 20210917 Javadoc fixed. 
 **     CA  20220120 Allow OO vars to be registered as pending, at their definition.
+**     CA  20220901 Refactored scope notification support: ScopeableFactory was removed, and the registration 
+**                  is now specific to each type of scopeable.  For each case, the block will be registered 
+**                  for scope support (for that particular scopeable) only when the scopeable is 'active' 
+**                  (i.e. unnamed streams or accumulators are used).  This allows a lazy registration of 
+**                  scopeables, to avoid the unnecessary overhead of processing all the scopeables for each
+**                  and every block.
 */
 
 /*
@@ -717,6 +723,8 @@
    public static <V extends Object> jobject<V> jobject(Class<V> cls)
    {
       jobject<V> res = new jobject<V>(cls);
+
+      ObjectOps.registerPending(res);
       
       return res;
    }

=== modified file 'src/com/goldencode/p2j/util/UnnamedStreams.java'
--- old/src/com/goldencode/p2j/util/UnnamedStreams.java	2022-01-14 22:38:33 +0000
+++ new/src/com/goldencode/p2j/util/UnnamedStreams.java	2022-09-06 18:22:04 +0000
@@ -65,6 +65,12 @@
 **                           and scopeFinished. Once something non-null is added to the closer stack, then
 **                           it's the job of executeOnReturn to pop the stack, otherwise, it's on the
 **                           scopeFinished. Ref #5880.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 
 /*
@@ -329,21 +335,6 @@
       
       work.get().wa.both = false;
    }      
-   
-   /**
-    * Register with the {@link com.goldencode.p2j.util.TransactionManager TransactionManager} a
-    * factory object which creates instances of this class, so that they can be registered to
-    * receive notifications of runtime scope start and finish events.
-    * <p>
-    * This method should be invoked once during the server bootstrap phase.
-    * <p>
-    * The registered factory functions conditionally. It uses the {@link
-    * TransactionManager#_isHeadless()} to check whether the context has been declared headless.
-    */
-   public static void initialize()
-   {
-      TransactionManager.registerScopeableFactory(() -> TransactionManager._isHeadless() ? null : work.get());
-   }
 
    /**
     * Provides a notification that a new scope is about to be entered. Used
@@ -351,13 +342,10 @@
     */
    public void scopeStart()
    {
-      if (wa.tm.isTopLevelBlock())
-      {
-         wa.lastIn.push(wa.in);
-         wa.lastOut.push(wa.out);
-         wa.closerIn.push(null);
-         wa.closerOut.push(null);
-      }
+      wa.lastIn.push(wa.in);
+      wa.lastOut.push(wa.out);
+      wa.closerIn.push(null);
+      wa.closerOut.push(null);
    }
    
    /**
@@ -367,19 +355,16 @@
     */
    public void scopeFinished()
    {
-      if (wa.tm.isTopLevelBlock())
-      {
-         wa.lastIn.pop();
-         wa.lastOut.pop();
+      wa.lastIn.pop();
+      wa.lastOut.pop();
 
-         if (wa.closerIn.peek() == null)
-         {
-            wa.closerIn.pop();
-         }
-         if (wa.closerOut.peek() == null)
-         {
-            wa.closerOut.pop();
-         }
+      if (wa.closerIn.peek() == null)
+      {
+         wa.closerIn.pop();
+      }
+      if (wa.closerOut.peek() == null)
+      {
+         wa.closerOut.pop();
       }
    }
 
@@ -393,6 +378,17 @@
    {
       // no-op
    }
+   
+   /**
+    * Get the {@link ScopeId} for the instance.
+    * 
+    * @return   {@link ScopeId#UNNAMED_STREAMS}.
+    */
+   @Override
+   public ScopeId getScopeId()
+   {
+      return ScopeId.UNNAMED_STREAMS;
+   }
 
    /**
     * State of the output side of the unnamed stream.
@@ -449,6 +445,8 @@
     */
    private static void assignInWorker(WorkArea wa, Stream in, boolean register)
    {
+      wa.tm.registerTopLevelScopeable(work.get());
+
       // default input for this top level scope
       Stream def = wa.lastIn.peek();
       
@@ -508,6 +506,8 @@
     */
    private static void assignOutWorker(WorkArea wa, Stream out, boolean register)
    {
+      wa.tm.registerTopLevelScopeable(work.get());
+      
       // save ids before we make any state changes
       int oldId = ((wa.out == null) ? -1 : ((RemoteStream) wa.out).getId()); 
       int newId = ((out    == null) ? -1 : ((RemoteStream) out).getId());

